import { Viewer } from '@grapecity/activereports/reportviewer';
import { Designer, templates } from '@grapecity/activereports/reportdesigner';
import { exportDocument } from '@grapecity/activereports/pdfexport';
import { exportDocument as exportDocument$1 } from '@grapecity/activereports/xlsxexport';
import { __extends, __awaiter, __generator, __values, __spread } from 'tslib';
import { exportDocument as exportDocument$2 } from '@grapecity/activereports/htmlexport';
import { InjectionToken, Component, Input, ViewEncapsulation, EventEmitter, Output, Inject, Optional, ViewChild, NgModule, Injectable, defineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/export-injectiontoken.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var AR_EXPORTS = new InjectionToken('AR_EXPORTS');
/**
 * @abstract
 */
var  /**
 * @abstract
 */
Export = /** @class */ (function () {
    function Export() {
    }
    return Export;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/viewer/viewer.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ViewerComponent = /** @class */ (function () {
    function ViewerComponent(supportedExports) {
        var _this = this;
        this.supportedExports = supportedExports;
        this._initProps = [];
        this.width = '100%';
        this.height = '100%';
        this.availableExports = [];
        this.init = new EventEmitter();
        this.reportLoaded = new EventEmitter();
        this.documentLoaded = new EventEmitter();
        this._propSetters = {
            sidebarVisible: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.toggleSidebar(value); }),
            toolbarVisible: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.toggleToolbar(value); }),
            fullscreen: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.toggleFullScreen(value); }),
            availableExports: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value && value.length > 0) {
                    /** @type {?} */
                    var supportedValues = value.filter((/**
                     * @param {?} v
                     * @return {?}
                     */
                    function (v) { return _this.supportedExportKeys.indexOf(v) >= 0; }));
                    // set ['disabled'] to hide export panel if no exports supported
                    _this._viewer.availableExports = supportedValues.length ? supportedValues : ['disabled'];
                }
                else {
                    // set explicit list to avoid side effects of global exports initialization
                    _this._viewer.availableExports = _this.supportedExportKeys.length ? _this.supportedExportKeys : ['disabled'];
                }
            }),
            mouseMode: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.mouseMode = value; }),
            renderMode: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.renderMode = value; }),
            viewMode: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.viewMode = value; }),
            zoom: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.zoom = value; }),
            errorHandler: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { _this._viewer.errorHandler = value; }),
        };
        this._disposables = [];
    }
    Object.defineProperty(ViewerComponent.prototype, "supportedExportKeys", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            return (this.supportedExports || []).map((/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return e.key; }));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} changes
     * @return {?}
     */
    ViewerComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        var e_1, _a;
        var _loop_1 = function (prop) {
            /** @type {?} */
            var setter = this_1._propSetters[prop];
            if (!setter) {
                return "continue";
            }
            /** @type {?} */
            var value = changes[prop].currentValue;
            if (this_1._viewer) {
                setter(value);
            }
            else {
                this_1._initProps.push((/**
                 * @return {?}
                 */
                function () { return setter(value); }));
            }
        };
        var this_1 = this;
        try {
            for (var _b = __values(Object.keys(changes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var prop = _c.value;
                _loop_1(prop);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @return {?}
     */
    ViewerComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.initViewer()
            .then((/**
         * @return {?}
         */
        function () { return _this.init.emit(_this); }));
    };
    /**
     * @return {?}
     */
    ViewerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        while (this._disposables.length) {
            (/** @type {?} */ (this._disposables.shift()))();
            this._viewer.dispose();
        }
    };
    Object.defineProperty(ViewerComponent.prototype, "ref", {
        get: /**
         * @return {?}
         */
        function () {
            return this._viewer;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @return {?}
     */
    ViewerComponent.prototype.initViewer = /**
     * @private
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, _b, _c, supportedExport, e_2_1;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 7]);
                        _b = __values(this.supportedExports || []), _c = _b.next();
                        _d.label = 1;
                    case 1:
                        if (!!_c.done) return [3 /*break*/, 4];
                        supportedExport = _c.value;
                        return [4 /*yield*/, supportedExport.init()];
                    case 2:
                        _d.sent();
                        _d.label = 3;
                    case 3:
                        _c = _b.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 7:
                        this._viewer = new Viewer(this.rootElement.nativeElement, {
                            language: this.language,
                            PanelsLocation: this.panelsLayout != null ? this.panelsLayout : this.panelsLocation,
                            ParameterPanelLocation: this.parameterPanelLocation,
                            ToolbarLayout: this.toolbarLayout,
                            ExportsSettings: this.exportsSettings,
                        });
                        this._disposables.push(this._viewer.reportLoaded.register((/**
                         * @param {?} args
                         * @return {?}
                         */
                        function (args) { return _this.reportLoaded.emit(args); })), this._viewer.documentLoaded.register((/**
                         * @param {?} args
                         * @return {?}
                         */
                        function (args) { return _this.documentLoaded.emit(args); })));
                        this._propSetters.availableExports(this.availableExports);
                        while (this._initProps.length) {
                            (/** @type {?} */ (this._initProps.shift()))();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Opens report from file or as definition (json string)).
     *
     * @param report  The report template. Can be report URI, or report definition, or instance of PageReport class.
     * @param settings  Additional settings for report (name, parameters).
     */
    /**
     * Opens report from file or as definition (json string)).
     *
     * @param {?} report  The report template. Can be report URI, or report definition, or instance of PageReport class.
     * @param {?=} settings  Additional settings for report (name, parameters).
     * @return {?}
     */
    ViewerComponent.prototype.open = /**
     * Opens report from file or as definition (json string)).
     *
     * @param {?} report  The report template. Can be report URI, or report definition, or instance of PageReport class.
     * @param {?=} settings  Additional settings for report (name, parameters).
     * @return {?}
     */
    function (report, settings) {
        return this._viewer.open(report, settings);
    };
    /**
     * Exports currently displayed report to specified output format. Returns object which contains
     * result data as blob object | string and download function. So you could either use this blob object or download file immediately.
     * Please note that you can specify settings in PDF export as plain list
     * (like **{title: 'Title', author: 'Author Name', ownerPassword: '1'}** etc...
     *
     * ```javascript
     * var options = {filename:"Invoice List"};
     * var cancelCallback = function(){
     *     return false; // continue export. Return true to cancel export process
     * }
     * viewer.export('pdf', options, {cancel: cancelCallback }).then(result => doSmthWithBlob(result.data));
     * //or you can download file
     * viewer.export('pdf', options, {cancel: cancelCallback }).then(result => result.download('Invoice List'));
     * ```
     *
     * @param format  Export format identifier. One of 'pdf', 'xlsx' or 'html'.
     * @param settings  Format specific export settings.
     * @param params  Additional export customization.
     */
    /**
     * Exports currently displayed report to specified output format. Returns object which contains
     * result data as blob object | string and download function. So you could either use this blob object or download file immediately.
     * Please note that you can specify settings in PDF export as plain list
     * (like **{title: 'Title', author: 'Author Name', ownerPassword: '1'}** etc...
     *
     * ```javascript
     * var options = {filename:"Invoice List"};
     * var cancelCallback = function(){
     *     return false; // continue export. Return true to cancel export process
     * }
     * viewer.export('pdf', options, {cancel: cancelCallback }).then(result => doSmthWithBlob(result.data));
     * //or you can download file
     * viewer.export('pdf', options, {cancel: cancelCallback }).then(result => result.download('Invoice List'));
     * ```
     *
     * @param {?} format  Export format identifier. One of 'pdf', 'xlsx' or 'html'.
     * @param {?} settings  Format specific export settings.
     * @param {?=} params  Additional export customization.
     * @return {?}
     */
    ViewerComponent.prototype.export = /**
     * Exports currently displayed report to specified output format. Returns object which contains
     * result data as blob object | string and download function. So you could either use this blob object or download file immediately.
     * Please note that you can specify settings in PDF export as plain list
     * (like **{title: 'Title', author: 'Author Name', ownerPassword: '1'}** etc...
     *
     * ```javascript
     * var options = {filename:"Invoice List"};
     * var cancelCallback = function(){
     *     return false; // continue export. Return true to cancel export process
     * }
     * viewer.export('pdf', options, {cancel: cancelCallback }).then(result => doSmthWithBlob(result.data));
     * //or you can download file
     * viewer.export('pdf', options, {cancel: cancelCallback }).then(result => result.download('Invoice List'));
     * ```
     *
     * @param {?} format  Export format identifier. One of 'pdf', 'xlsx' or 'html'.
     * @param {?} settings  Format specific export settings.
     * @param {?=} params  Additional export customization.
     * @return {?}
     */
    function (format, settings, params) {
        return this._viewer.export(format, settings, params);
    };
    /**
     * Resets current viewer document
     */
    /**
     * Resets current viewer document
     * @return {?}
     */
    ViewerComponent.prototype.resetDocument = /**
     * Resets current viewer document
     * @return {?}
     */
    function () {
        return this._viewer.resetDocument();
    };
    /**
     * Prints currently displayed report.
     */
    /**
     * Prints currently displayed report.
     * @return {?}
     */
    ViewerComponent.prototype.print = /**
     * Prints currently displayed report.
     * @return {?}
     */
    function () {
        return this._viewer.print();
    };
    Object.defineProperty(ViewerComponent.prototype, "currentPage", {
        /** Gets current page number (1-based). Returns 0 if no document loaded. */
        get: /**
         * Gets current page number (1-based). Returns 0 if no document loaded.
         * @return {?}
         */
        function () {
            return this._viewer.currentPage;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewerComponent.prototype, "pageCount", {
        /** Gets the total number of pages available in report. */
        get: /**
         * Gets the total number of pages available in report.
         * @return {?}
         */
        function () {
            return this._viewer.pageCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewerComponent.prototype, "history", {
        /** Provides access to the "history" API. */
        get: /**
         * Provides access to the "history" API.
         * @return {?}
         */
        function () {
            return this._viewer.history;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewerComponent.prototype, "toolbar", {
        /** Gets the toolbar API */
        get: /**
         * Gets the toolbar API
         * @return {?}
         */
        function () {
            return this._viewer.toolbar;
        },
        enumerable: true,
        configurable: true
    });
    /** Navigates to the first page. */
    /**
     * Navigates to the first page.
     * @return {?}
     */
    ViewerComponent.prototype.goToFirstPage = /**
     * Navigates to the first page.
     * @return {?}
     */
    function () {
        return this._viewer.goToFirstPage();
    };
    /** Navigates to the previous page. */
    /**
     * Navigates to the previous page.
     * @return {?}
     */
    ViewerComponent.prototype.goToPrevPage = /**
     * Navigates to the previous page.
     * @return {?}
     */
    function () {
        return this._viewer.goToPrevPage();
    };
    /** Navigates to the next page. */
    /**
     * Navigates to the next page.
     * @return {?}
     */
    ViewerComponent.prototype.goToNextPage = /**
     * Navigates to the next page.
     * @return {?}
     */
    function () {
        return this._viewer.goToNextPage();
    };
    /** Navigates to the last page. */
    /**
     * Navigates to the last page.
     * @return {?}
     */
    ViewerComponent.prototype.goToLastPage = /**
     * Navigates to the last page.
     * @return {?}
     */
    function () {
        return this._viewer.goToLastPage();
    };
    /** Navigates to the specified page (starting from 1). */
    /**
     * Navigates to the specified page (starting from 1).
     * @param {?} pageNumber
     * @return {?}
     */
    ViewerComponent.prototype.goToPage = /**
     * Navigates to the specified page (starting from 1).
     * @param {?} pageNumber
     * @return {?}
     */
    function (pageNumber) {
        return this._viewer.goToPage(pageNumber);
    };
    /** Performs backToParent action which will return user to parent report. */
    /**
     * Performs backToParent action which will return user to parent report.
     * @return {?}
     */
    ViewerComponent.prototype.backToParent = /**
     * Performs backToParent action which will return user to parent report.
     * @return {?}
     */
    function () {
        return this._viewer.backToParent();
    };
    /** Performs refresh operation in report (re-render report). */
    /**
     * Performs refresh operation in report (re-render report).
     * @return {?}
     */
    ViewerComponent.prototype.refresh = /**
     * Performs refresh operation in report (re-render report).
     * @return {?}
     */
    function () {
        return this._viewer.refresh();
    };
    Object.defineProperty(ViewerComponent.prototype, "canBackToParent", {
        /** Gets **true** if backToParent command is applicable to current document. */
        get: /**
         * Gets **true** if backToParent command is applicable to current document.
         * @return {?}
         */
        function () {
            return this._viewer.canBackToParent();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Register specified fonts in CSS and pdf export. Helps display export correctly on machines where fonts can be missed.
     */
    /**
     * Register specified fonts in CSS and pdf export. Helps display export correctly on machines where fonts can be missed.
     * @param {...?} fonts
     * @return {?}
     */
    ViewerComponent.prototype.registerFont = /**
     * Register specified fonts in CSS and pdf export. Helps display export correctly on machines where fonts can be missed.
     * @param {...?} fonts
     * @return {?}
     */
    function () {
        var fonts = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            fonts[_i] = arguments[_i];
        }
        var _a;
        return (_a = this._viewer).registerFont.apply(_a, __spread(fonts));
    };
    /**
     * Performs search operation in currently rendered report. Allows you to create your own custom search pane.
     */
    /**
     * Performs search operation in currently rendered report. Allows you to create your own custom search pane.
     * @param {?} options
     * @param {?} resultFn
     * @param {?=} progressFn
     * @param {?=} cancel
     * @return {?}
     */
    ViewerComponent.prototype.search = /**
     * Performs search operation in currently rendered report. Allows you to create your own custom search pane.
     * @param {?} options
     * @param {?} resultFn
     * @param {?=} progressFn
     * @param {?=} cancel
     * @return {?}
     */
    function (options, resultFn, progressFn, cancel) {
        return this._viewer.search(options, resultFn, progressFn, cancel);
    };
    /**
     * Highlights the search result returned by a search method.
     */
    /**
     * Highlights the search result returned by a search method.
     * @param {?} result
     * @return {?}
     */
    ViewerComponent.prototype.highlight = /**
     * Highlights the search result returned by a search method.
     * @param {?} result
     * @return {?}
     */
    function (result) {
        return this._viewer.highlight(result);
    };
    ViewerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'gc-activereports-viewer',
                    template: "<div #viewerRoot [style.width]=\"width\" [style.height]=\"height\"></div>",
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ViewerComponent.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [AR_EXPORTS,] }, { type: Optional }] }
    ]; };
    ViewerComponent.propDecorators = {
        rootElement: [{ type: ViewChild, args: ['viewerRoot',] }],
        width: [{ type: Input }],
        height: [{ type: Input }],
        language: [{ type: Input }],
        panelsLocation: [{ type: Input }],
        panelsLayout: [{ type: Input }],
        parameterPanelLocation: [{ type: Input }],
        toolbarLayout: [{ type: Input }],
        exportsSettings: [{ type: Input }],
        availableExports: [{ type: Input }],
        mouseMode: [{ type: Input }],
        renderMode: [{ type: Input }],
        viewMode: [{ type: Input }],
        zoom: [{ type: Input }],
        fullscreen: [{ type: Input }],
        toolbarVisible: [{ type: Input }],
        sidebarVisible: [{ type: Input }],
        errorHandler: [{ type: Input }],
        init: [{ type: Output }],
        reportLoaded: [{ type: Output }],
        documentLoaded: [{ type: Output }]
    };
    return ViewerComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/designer/designer.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?=} report
 * @return {?}
 */
function isReportDef(report) {
    return !!(report && ((/** @type {?} */ (report))).definition);
}
/**
 * @param {?} curr
 * @param {?} prev
 * @return {?}
 */
function hasReportChanged(curr, prev) {
    /** @type {?} */
    var definitionChanged = (isReportDef(curr) && curr.definition) !== (isReportDef(curr) && curr.definition);
    return (definitionChanged || (curr && curr.id) !== (prev && prev.id) || (curr && curr.displayName) !== (prev && prev.displayName));
}
var DesignerComponent = /** @class */ (function () {
    function DesignerComponent() {
        /**
         * Sets componets width
         */
        this.width = '100%';
        /**
         * Sets componets height
         */
        this.height = '100%';
        this._actionHandlers = {};
    }
    Object.defineProperty(DesignerComponent.prototype, "fontSet", {
        /** Gets available set of fonts. */
        get: /**
         * Gets available set of fonts.
         * @return {?}
         */
        function () {
            return this._fontSet;
        },
        /** Sets available set of fonts. */
        set: /**
         * Sets available set of fonts.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._fontSet = value;
            if (this._designer)
                this._designer.fontSet = this._fontSet || 'all';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "dataSources", {
        /* Gets DataSource templates */
        get: /* Gets DataSource templates */
        /**
         * @return {?}
         */
        function () {
            return this._dataSources;
        },
        /**
         * Sets DataSource templates
         * @param value List of DataSource templates
         */
        set: /**
         * Sets DataSource templates
         * @param {?} value List of DataSource templates
         * @return {?}
         */
        function (value) {
            this._dataSources = value;
            if (this._designer)
                this._designer.setDataSourceTemplates(this._dataSources || []);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "onCreate", {
        get: /**
         * @return {?}
         */
        function () {
            return this._actionHandlers.onCreate;
        },
        /**
         * Sets handler to be called on open report.
         * Handler return Promise with report info or 'undefined' if operation was cancelled.
         */
        set: /**
         * Sets handler to be called on open report.
         * Handler return Promise with report info or 'undefined' if operation was cancelled.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._actionHandlers.onCreate = value;
            if (this._designer)
                this._designer.setActionHandlers(this._actionHandlers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "onOpen", {
        get: /**
         * @return {?}
         */
        function () {
            return this._actionHandlers.onOpen;
        },
        /**
         * Sets handler to be called on opening report.
         * Handler returns Promise with report info or 'undefined' if operation was cancelled.
         */
        set: /**
         * Sets handler to be called on opening report.
         * Handler returns Promise with report info or 'undefined' if operation was cancelled.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._actionHandlers.onOpen = value;
            if (this._designer)
                this._designer.setActionHandlers(this._actionHandlers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "onRender", {
        get: /**
         * @return {?}
         */
        function () {
            return this._actionHandlers.onRender;
        },
        /**
         * Sets handler to be called on request to render current report.
         */
        set: /**
         * Sets handler to be called on request to render current report.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._actionHandlers.onRender = value;
            if (this._designer)
                this._designer.setActionHandlers(this._actionHandlers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "onSave", {
        get: /**
         * @return {?}
         */
        function () {
            return this._actionHandlers.onSave;
        },
        /**
         * Sets handler to be called on saving report.
         * Handler returns Promise with new report info if report was saved or 'undefined' if operation was cancelled.
         */
        set: /**
         * Sets handler to be called on saving report.
         * Handler returns Promise with new report info if report was saved or 'undefined' if operation was cancelled.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._actionHandlers.onSave = value;
            if (this._designer)
                this._designer.setActionHandlers(this._actionHandlers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "onSaveAs", {
        get: /**
         * @return {?}
         */
        function () {
            return this._actionHandlers.onSaveAs;
        },
        /**
         * Sets handler to be called on saving report as new.
         * Handler returns Promise with new report info if report was saved or 'undefined' if operation was cancelled.
         */
        set: /**
         * Sets handler to be called on saving report as new.
         * Handler returns Promise with new report info if report was saved or 'undefined' if operation was cancelled.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._actionHandlers.onSaveAs = value;
            if (this._designer)
                this._designer.setActionHandlers(this._actionHandlers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "onOpenFileMenu", {
        get: /**
         * @return {?}
         */
        function () {
            return this._actionHandlers.onOpenFileMenu;
        },
        /**
         * Sets handler to be called on open custom file menu.
         */
        set: /**
         * Sets handler to be called on open custom file menu.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._actionHandlers.onOpenFileMenu = value;
            if (this._designer)
                this._designer.setActionHandlers(this._actionHandlers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DesignerComponent.prototype, "report", {
        /**
         * Watch report property
        */
        set: /**
         * Watch report property
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (hasReportChanged(value, this._report)) {
                this._report = value;
                this.setReport(value || { definition: templates.CPL }, 'override');
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DesignerComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var config = {
            disableOpenSaveHotkeys: this.hotkeysEnabled === false,
            language: this.language,
            customInitTemplates: this.customInitTemplates,
        };
        this._designer = new Designer(this.rootElement.nativeElement, config);
        this._designer.setResourceProvider({
            getImagesList: (/**
             * @return {?}
             */
            function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/, this.imageList || []];
            }); }); }),
            getReportsList: (/**
             * @return {?}
             */
            function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/, this.reportList || []];
            }); }); }),
            getThemesList: (/**
             * @return {?}
             */
            function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/, this.themeList || []];
            }); }); }),
        });
        this._designer.setActionHandlers(this._actionHandlers);
        if (this.fontSet)
            this._designer.fontSet = this.fontSet;
        if (this.dataSources)
            this._designer.setDataSourceTemplates(this._dataSources || []);
        if (this._report)
            this.setReport(this._report || { definition: templates.CPL }, 'override');
    };
    /**
     * Sets report.
     * @param report Report info to load.
     * @param whenDirty Action to perform in case of 'dirty' report.
     */
    /**
     * Sets report.
     * @param {?} report Report info to load.
     * @param {?=} whenDirty Action to perform in case of 'dirty' report.
     * @return {?}
     */
    DesignerComponent.prototype.setReport = /**
     * Sets report.
     * @param {?} report Report info to load.
     * @param {?=} whenDirty Action to perform in case of 'dirty' report.
     * @return {?}
     */
    function (report, whenDirty) {
        if (!this._designer)
            return Promise.resolve();
        return this._designer.setReport(report, whenDirty);
    };
    /** Gets current report. */
    /**
     * Gets current report.
     * @return {?}
     */
    DesignerComponent.prototype.getReport = /**
     * Gets current report.
     * @return {?}
     */
    function () {
        if (!this._designer)
            return (/** @type {?} */ (Promise.resolve()));
        return this._designer.getReport();
    };
    /**
     * Process command.
     * @param cmd Command name.
     */
    /**
     * Process command.
     * @param {?} cmd Command name.
     * @return {?}
     */
    DesignerComponent.prototype.processCommand = /**
     * Process command.
     * @param {?} cmd Command name.
     * @return {?}
     */
    function (cmd) {
        if (!this._designer)
            return Promise.resolve();
        return this._designer.processCommand(cmd);
    };
    DesignerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'gc-activereports-designer',
                    template: "<div #designerRoot [style.width]=\"width\" [style.height]=\"height\"></div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DesignerComponent.ctorParameters = function () { return []; };
    DesignerComponent.propDecorators = {
        rootElement: [{ type: ViewChild, args: ['designerRoot',] }],
        width: [{ type: Input }],
        height: [{ type: Input }],
        hotkeysEnabled: [{ type: Input }],
        language: [{ type: Input }],
        customInitTemplates: [{ type: Input }],
        fontSet: [{ type: Input }],
        dataSources: [{ type: Input }],
        reportList: [{ type: Input }],
        imageList: [{ type: Input }],
        themeList: [{ type: Input }],
        onCreate: [{ type: Input }],
        onOpen: [{ type: Input }],
        onRender: [{ type: Input }],
        onSave: [{ type: Input }],
        onSaveAs: [{ type: Input }],
        onOpenFileMenu: [{ type: Input }],
        report: [{ type: Input }]
    };
    return DesignerComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/activereports.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ActiveReportsModule = /** @class */ (function () {
    function ActiveReportsModule() {
    }
    ActiveReportsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ViewerComponent, DesignerComponent],
                    imports: [],
                    exports: [ViewerComponent, DesignerComponent]
                },] }
    ];
    return ActiveReportsModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/pdf-export.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PdfExportService = /** @class */ (function (_super) {
    __extends(PdfExportService, _super);
    function PdfExportService() {
        var _this = _super.call(this) || this;
        _this.key = 'pdf';
        return _this;
    }
    /**
     * @return {?}
     */
    PdfExportService.prototype.init = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // 'exportDocument' must be used to avoid tree-shaking
                if (typeof exportDocument !== 'function') {
                    console.error("Invalid \"" + this.key + "\" export module.");
                }
                return [2 /*return*/];
            });
        });
    };
    PdfExportService.decorators = [
        { type: Injectable, args: [{
                    providedIn: ViewerComponent
                },] }
    ];
    /** @nocollapse */
    PdfExportService.ctorParameters = function () { return []; };
    /** @nocollapse */ PdfExportService.ngInjectableDef = defineInjectable({ factory: function PdfExportService_Factory() { return new PdfExportService(); }, token: PdfExportService, providedIn: ViewerComponent });
    return PdfExportService;
}(Export));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/xlsx-export.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XlsxExportService = /** @class */ (function (_super) {
    __extends(XlsxExportService, _super);
    function XlsxExportService() {
        var _this = _super.call(this) || this;
        _this.key = 'xlsx';
        return _this;
    }
    /**
     * @return {?}
     */
    XlsxExportService.prototype.init = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // 'exportDocument' must be used to avoid tree-shaking
                if (typeof exportDocument$1 !== 'function') {
                    console.error("Invalid \"" + this.key + "\" export module.");
                }
                return [2 /*return*/];
            });
        });
    };
    XlsxExportService.decorators = [
        { type: Injectable, args: [{
                    providedIn: ViewerComponent
                },] }
    ];
    /** @nocollapse */
    XlsxExportService.ctorParameters = function () { return []; };
    /** @nocollapse */ XlsxExportService.ngInjectableDef = defineInjectable({ factory: function XlsxExportService_Factory() { return new XlsxExportService(); }, token: XlsxExportService, providedIn: ViewerComponent });
    return XlsxExportService;
}(Export));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/html-export.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var HtmlExportService = /** @class */ (function (_super) {
    __extends(HtmlExportService, _super);
    function HtmlExportService() {
        var _this = _super.call(this) || this;
        _this.key = 'html';
        return _this;
    }
    /**
     * @return {?}
     */
    HtmlExportService.prototype.init = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // 'exportDocument' must be used to avoid tree-shaking
                if (typeof exportDocument$2 !== 'function') {
                    console.error("Invalid \"" + this.key + "\" export module.");
                }
                return [2 /*return*/];
            });
        });
    };
    HtmlExportService.decorators = [
        { type: Injectable, args: [{
                    providedIn: ViewerComponent
                },] }
    ];
    /** @nocollapse */
    HtmlExportService.ctorParameters = function () { return []; };
    /** @nocollapse */ HtmlExportService.ngInjectableDef = defineInjectable({ factory: function HtmlExportService_Factory() { return new HtmlExportService(); }, token: HtmlExportService, providedIn: ViewerComponent });
    return HtmlExportService;
}(Export));

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: grapecity-activereports-angular.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ViewerComponent, DesignerComponent, ActiveReportsModule, PdfExportService, XlsxExportService, HtmlExportService, AR_EXPORTS, Export };

//# sourceMappingURL=grapecity-activereports-angular.js.map